<?php

namespace Drupal\pagedesigner_yoast\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\text\Plugin\Field\FieldWidget\TextareaWithSummaryWidget;

/**
 * Advanced widget for yoast_seo field.
 *
 * @FieldWidget(
 *   id = "pagedesigner_yoast_seo_body_widget",
 *   label = @Translation("Pagedesigner body field widget"),
 *   field_types = {
 *     "text_with_summary"
 *   }
 * )
 */
class PagedesignerYoastSeoBodyWidget extends TextareaWithSummaryWidget
{

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state)
  {

    //$node = \Drupal::entityTypeManager()->getStorage('node')->load(58);
    $node = \Drupal::routeMatch()->getParameter('node');

    if ($node != null) {

      $theme_initialization = \Drupal::service('theme.initialization');
      $current_theme = \Drupal::service('theme.manager')->getActiveTheme();
      \Drupal::service('theme.manager')->setActiveTheme($theme_initialization->getActiveThemeByName('iq_custom'));
      $renderer = \Drupal::service('pagedesigner.service.renderer');
      $renderer->renderForPublic($node);
      $markup = $renderer->getMarkup($node);
      \Drupal::service('theme.manager')->setActiveTheme($current_theme);
    } else {
      $markup = '';
    }

    // strip tags that will break editor
    $tags_to_strip = Array("textarea");
    foreach ($tags_to_strip as $tag) {
      $markup = preg_replace("/<\\/?" . $tag . "(.|\\s)*?>/",'',$markup);
    }

    $items->setValue([
      'value' =>   $markup,   //'<p>sali zäme, e be de dan man</p>',
      'format' => 'pagedesigner'
    ]);





    return parent::formElement($items, $delta, $element, $form, $form_state);
  }
}
